package com.sigmaflare.binancej.entities;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.sigmaflare.binancej.entities.transform.CandlestickDeserializer;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.math.BigDecimal;

/**
 * Represents a single candlestick/kline. No JsonProperty information is stored because we use a
 * custom serializer to clean up the data that's given to us from the endpoint.
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@JsonDeserialize(using = CandlestickDeserializer.class)
public class Candlestick {
   private long openTime;

   private BigDecimal open;

   private BigDecimal high;

   private BigDecimal low;

   private BigDecimal close;

   private BigDecimal volume;

   private long closeTime;

   private BigDecimal quoteAssetVolume;

   private long numberOfTrades;

   private BigDecimal takerBuyBaseAssetVolume;

   private BigDecimal takerBuyQuoteAssetVolume;
}
