package com.sigmaflare.binancej.entities;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.NonNull;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class ExchangeInfo {
    @NonNull
    @JsonProperty("timezone")
    private String timezone;

    @JsonProperty("serverTime")
    private Long serverTime;

    @NonNull
    @JsonProperty("rateLimits")
    private Set<RateLimit> rateLimits;

    @NonNull
    @JsonProperty("exchangeFilters")
    private Set<ExchangeFilter> exchangeFilters;

    @NonNull
    @JsonProperty("symbols")
    private List<Symbol> symbols;
}
