package com.sigmaflare.binancej.entities;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.sigmaflare.binancej.entities.transform.OrderBookDepthResponseDeserializer;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

/**
 * Represents the Order book depth for Binance's market.
 *
 * Order book depth is a mess coming from Binance's API, so this is handled purely with
 * a custom deserializer to make using the resulting POJOs easier
 */
@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
@JsonDeserialize(using = OrderBookDepthResponseDeserializer.class)
public class OrderBookDepth {
    private long lastUpdateId;

    private List<OrderBookPricing> bids;

    private List<OrderBookPricing> asks;
}
