package com.sigmaflare.binancej.entities;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import lombok.NonNull;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

@Data
@Builder
@AllArgsConstructor
@NoArgsConstructor
public class Symbol {
    @NonNull
    @JsonProperty("symbol")
    private String ticker;

    @NonNull
    @JsonProperty("status")
    private SymbolStatus symbolStatus;

    @NonNull
    @JsonProperty("baseAsset")
    private String baseAsset;

    @JsonProperty("baseAssetPrecision")
    private int baseAssetPrecision;

    @NonNull
    @JsonProperty("quoteAsset")
    private String quoteAsset;

    @JsonProperty("quotePrecision")
    private int quotePrecision;

    @NonNull
    @JsonProperty("orderTypes")
    private Set<OrderType> orderTypes;

    @JsonProperty("icebergAllowed")
    private boolean icebergAllowed;

    @NonNull
    @JsonProperty("filters")
    private List<SymbolFilter> symbolFilters;
}
